unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ItemProp, FileCtrl, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    btnProperties: TButton;
    btnContextMenu: TButton;
    btnDefaultAction: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    procedure Edit1Change(Sender: TObject);
    procedure btnPropertiesClick(Sender: TObject);
    procedure btnContextMenuClick(Sender: TObject);
    procedure btnDefaultActionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure AppHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Edit1Change(Sender: TObject);
var
  b: boolean;
begin
  b := FileExists(Edit1.Text) or DirectoryExists(Edit1.Text);
  btnProperties.Enabled := b;
  btnContextMenu.Enabled := b;
  btnDefaultAction.Enabled := b;
end;

procedure TForm1.btnPropertiesClick(Sender: TObject);
begin
  if not DisplayPropertiesDialog(Edit1.Text, Handle) then
    ShowMessage('DisplayPropertiesDialog failed!');
end;

procedure TForm1.btnContextMenuClick(Sender: TObject);
var
  Pt: TPoint;
  RenameItem: boolean;
begin
  GetCursorPos(Pt);
  if not PtInRect(btnContextMenu.BoundsRect, (btnContextMenu.Owner as
    TControl).ScreenToClient(Pt)) then
    Pt := (btnContextMenu.Owner as TControl).ClientToScreen(Point(
      btnContextMenu.Left + btnContextMenu.Width div 2, btnContextMenu.Top +
      btnContextMenu.Height div 2));
  if not DisplayContextMenu(Edit1.Text, Handle, Pt, TRUE, RenameItem) then
    ShowMessage('DisplayContextMenu failed!')
  else
    if RenameItem then
      ShowMessage('User selected Rename item, you must write code to handle ' +
      'it.'#13'For example, if this were the focused list view item in your ' +
      'UI,'#13'you would do something like:'#13#13'    ListView1.ItemFocused.' +
      'EditCaption;');
end;

procedure TForm1.btnDefaultActionClick(Sender: TObject);
begin
  if not PerformDefaultAction(Edit1.Text, Handle) then
    ShowMessage('PerformDefaultAction failed!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := Application.EXEName;
  Application.OnHint := AppHint;
end;

procedure TForm1.AppHint(Sender: TObject);
begin
  Panel2.Caption := GetShortHint(Application.Hint);
  Panel3.Caption  := GetLongHint(Application.Hint);
end;

end.

